package com.ibm.swg.app.jobplan;

import java.rmi.RemoteException;

import psdi.mbo.MAXTableDomain;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSetInfo;
import psdi.mbo.MboValue;
import psdi.mbo.Translate;
import psdi.util.MXException;

import com.ibm.swg.util.DJPConstants;

public class FldDJPJobCalcLevel extends MAXTableDomain {

	public FldDJPJobCalcLevel(MboValue mbv) {
		super(mbv);

		try {
			MboSetInfo info = mbv.getMbo().getThisMboSet().getMboSetInfo();
			String mboObjectName = info.getObjectName();
			Translate t = mbv.getMbo().getTranslator();
			String relation;
			String listWhere;
			if ( mboObjectName.equals("JOBTASK") ) {
				listWhere = " type in (" + t.toExternalList("CALCAPPLYTO", "HOURS") + ")";
				relation = "resourcelevelsnum = :calclevel and " + listWhere;
			} else if ( mboObjectName.equals("JOBMATERIAL") ) {
				listWhere = " type in (" + t.toExternalList("CALCAPPLYTO", "QUANTITY") + ")";
				relation = "resourcelevelsnum = :calclevel and " + listWhere;
			} else {
				listWhere = " type = :calcapplyto";
				relation = "resourcelevelsnum = :calclevel and " + listWhere;
			}
			setRelationship("RESOURCELEVELS", relation);
			setListCriteria(listWhere);
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (MXException e) {
			e.printStackTrace();
		}
		
		
		String[] targetKeys = {"calclevel"};
		String[] sourceKeys = {"resourcelevelsnum"};
		setLookupKeyMapInOrder(targetKeys, sourceKeys);
	}
	
	@Override
	public void init() throws MXException, RemoteException {
		super.init();
		
		MboRemote jobplan = mboValue.getMbo();	// could be a JOBTASK, JLOBLABOR, JOBMATERIAL, JOBSERVICE, JOBTOOL, WPLABOR, WOACTIVITY, WPLABOR, WPMATERIAL, WPSERVICE, WPTOOL
		if ( !jobplan.isBasedOn("JOBPLAN") ) {
			jobplan = jobplan.getOwner();
			if ( !jobplan.isBasedOn("JOBPLAN") ) {
				mboValue.setFlag(READONLY, true);
				return;
			}
		}
		
		Translate t = getTranslator();
		String calcMethod = t.toInternalString("CALCMETHOD", getMboValue(DJPConstants.CALCMETHOD).getString());
		boolean byLevel = DJPConstants.CALCMETHOD_LEVEL.equals(calcMethod) || DJPConstants.CALCMETHOD_LEVEL_ATTRIBUTE.equals(calcMethod);
		
		mboValue.setFlag(READONLY, jobplan.getMboValueData("JPDURATION").isReadOnly() || !byLevel);
		mboValue.setFlag(REQUIRED, byLevel);
		
	}

}
