package com.ibm.swg.app.jobplan;

import java.rmi.RemoteException;

import psdi.app.jobplan.FldJobLaborLaborCode;
import psdi.mbo.MboConstants;
import psdi.mbo.MboValue;
import psdi.mbo.Translate;
import psdi.util.MXException;

import com.ibm.swg.util.DJPConstants;
import com.ibm.swg.util.DJPConstants.CalcApplyTo;

public class FldDJPJobLaborLaborCode extends FldJobLaborLaborCode {

	public FldDJPJobLaborLaborCode(MboValue mbv) throws MXException {
		super(mbv);
	}

	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		MboValue calcApplyTo = getMboValue(DJPConstants.CALCAPPLYTO);
		MboValue calcMethodMV = getMboValue(DJPConstants.CALCMETHOD);
		Translate t = getTranslator();
		
		if ( !mboValue.isNull() ) {
//			if ( !CalcApplyTo.HOURS.toString().equals(t.toInternalString("CALCAPPLYTO", calcApplyTo.getString())) ) {
			calcApplyTo.setValue(t.toExternalDefaultValue("CALCAPPLYTO", CalcApplyTo.HOURS.toString(), mboValue.getMbo()));	
//			}
		} else {
			MboValue laborHrs = getMboValue("LABORHRS");
			MboValue quantity = getMboValue("QUANTITY");
			
			String calcApplyToStr = t.toInternalString("CALCAPPLYTO", calcApplyTo.getString());
			switch(CalcApplyTo.fromStringTo(calcApplyToStr)) {
			case HOURS:
				laborHrs.setFlag(MboConstants.READONLY, true);
				quantity.setFlag(MboConstants.READONLY, false);
				break;
			case QUANTITY:
				quantity.setFlag(MboConstants.READONLY, true);
				laborHrs.setFlag(MboConstants.READONLY, false);
				break;
			case BOTH:
				laborHrs.setFlag(MboConstants.READONLY, true);
				quantity.setFlag(MboConstants.READONLY, true);
				break;
			}
		}
		
		String calcMethod = t.toInternalString("CALCMETHOD", calcMethodMV.getString());
		calcApplyTo.setFlag(READONLY, !mboValue.isNull() || DJPConstants.CALCMETHOD_STATIC.equals(calcMethod));
		
		
		
	}
}
