package com.ibm.swg.app.jobplan;

import java.rmi.RemoteException;

import psdi.mbo.MboRemote;
import psdi.mbo.MboValue;
import psdi.mbo.SynonymDomain;
import psdi.mbo.Translate;
import psdi.util.MXException;

import com.ibm.swg.util.DJPConstants;

public class FldDJPJobtaskCalcMethod extends SynonymDomain implements DJPConstants {
	
	
	public FldDJPJobtaskCalcMethod(MboValue mbv) {
		super(mbv);
		setDomainId("CALCMETHOD");
	}
	
	@Override
	public void init() throws MXException, RemoteException {
		super.init();
		
		MboRemote jobplan = mboValue.getMbo().getOwner();
		if ( !jobplan.isBasedOn("JOBPLAN") ) {
			mboValue.setFlag(READONLY, true);
			return;
		}
		
		mboValue.setFlag(REQUIRED, true);
		mboValue.setFlag(READONLY, jobplan.getMboValueData("JPDURATION").isReadOnly() );
	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		MboValue calcExpression = getMboValue(DJPConstants.CALCEXPRESSION);
		MboValue calcLevel      = getMboValue(DJPConstants.CALCLEVEL);
		
		Translate t = getTranslator();
		String calcMethod = t.toInternalString("CALCMETHOD", mboValue.getString());
		
		calcLevel.setValueNull(NOACCESSCHECK);
		calcExpression.setValueNull(NOACCESSCHECK);
		
		calcExpression.setFlag(REQUIRED, DJPConstants.CALCMETHOD_LEVEL_ATTRIBUTE.equals(calcMethod) || DJPConstants.CALCMETHOD_PROPORTIONAL_ATTRIBUTE.equals(calcMethod));
		calcExpression.setFlag(READONLY, DJPConstants.CALCMETHOD_STATIC.equals(calcMethod) || DJPConstants.CALCMETHOD_PROPORTIONAL.equals(calcMethod) || DJPConstants.CALCMETHOD_LEVEL.equals(calcMethod));
		
		calcLevel.setFlag(REQUIRED, DJPConstants.CALCMETHOD_LEVEL.equals(calcMethod) || DJPConstants.CALCMETHOD_LEVEL_ATTRIBUTE.equals(calcMethod));
		calcLevel.setFlag(READONLY, DJPConstants.CALCMETHOD_STATIC.equals(calcMethod) || DJPConstants.CALCMETHOD_PROPORTIONAL.equals(calcMethod) || DJPConstants.CALCMETHOD_PROPORTIONAL_ATTRIBUTE.equals(calcMethod));
		
	}

}
