package com.ibm.swg.app.jobplan.virtual;

import java.rmi.RemoteException;

import com.ibm.swg.util.DJPConstants;

import psdi.mbo.Mbo;
import psdi.mbo.MboRemote;
import psdi.mbo.MboServerInterface;
import psdi.mbo.MboSet;
import psdi.mbo.NonPersistentMboSet;
import psdi.util.MXException;

public class DynamicExpressionBuilderSet extends NonPersistentMboSet implements DynamicExpressionBuilderSetRemote {

	private String returnAttribute;

	public DynamicExpressionBuilderSet(MboServerInterface ms)
			throws RemoteException {
		super(ms);
	}

	@Override
	protected Mbo getMboInstance(MboSet ms) throws MXException, RemoteException {
		return new DynamicExpressionBuilder(ms);
	}
	
	@Override
	public MboRemote setup() throws MXException, RemoteException {
		MboRemote expBuilder = super.setup();

		MboRemote owner =  getOwner();
		expBuilder.setValue(DynamicExpressionBuilderRemote.CALCEXPRESSION,owner.getString(DJPConstants.CALCEXPRESSION));
		expBuilder.setValue("ORGID", owner.getString("ORGID"));
		expBuilder.setValue("SITEID", owner.getString("SITEID"));
		return expBuilder;
	}

	@Override
	public void setObjectAttribute(String dataAtt) {
		returnAttribute = dataAtt;
		
	}
	
	@Override
	public void execute() throws MXException, RemoteException {
		Mbo param = (Mbo) getMbo(0) ;
		MboRemote owner =  getOwner();
		owner.setValue(returnAttribute,param.getString(DynamicExpressionBuilderRemote.CALCEXPRESSION));
	}

}
