package com.ibm.swg.app.jobplan.virtual;

import java.rmi.RemoteException;

import com.ibm.swg.util.DJPConstants;

import psdi.mbo.MboRemote;
import psdi.mbo.MboValue;
import psdi.mbo.MboValueAdapter;
import psdi.util.MXApplicationException;
import psdi.util.MXException;

public class FldSimulationMeasure extends MboValueAdapter {

	public FldSimulationMeasure(MboValue mbv) {
		super(mbv);
	}

	@Override
	public void init() throws MXException, RemoteException {
		super.init();
		if ( mboValue.getMbo().getOwner().getOwner().getBoolean(DJPConstants.APPLYNONDYNAMICCALC)) {
			mboValue.setFlag(REQUIRED, false);
			mboValue.setFlag(READONLY, true);
			getMboValue(mboValue.getAttributeName() + "UNITID").setFlag(READONLY, true);
			getMboValue(mboValue.getAttributeName() + "UNITID").setFlag(REQUIRED, false);
		}
	}
	
	@Override
	public void validate() throws MXException, RemoteException {
		super.validate();
		MboRemote asset = mboValue.getMbo().getMboSet("ASSET").getMbo(0);
		if ( asset == null ) return;
		
		double startMeasure = asset.getDouble("STARTMEASURE");
		double endMeasure = asset.getDouble("ENDMEASURE");
		double newValue = mboValue.getDouble();
		if ( !(newValue >= startMeasure && newValue <= endMeasure) ) {
			throw new MXApplicationException("dynamicjobplan","invalidMeasure", new Object[]{newValue, startMeasure, endMeasure}); 
		}
		if ( mboValue.getAttributeName().equals("STARTMEASURE") && !getMboValue("ENDMEASURE").isNull() && getMboValue("ENDMEASURE").getDouble() < newValue ) {
			throw new MXApplicationException("dynamicjobplan","invalidMeasure", new Object[]{newValue, startMeasure, endMeasure}); 
		} else if ( mboValue.getAttributeName().equals("ENDMEASURE") && !getMboValue("STARTMEASURE").isNull() && getMboValue("STARTMEASURE").getDouble() > newValue ) {
			throw new MXApplicationException("dynamicjobplan","invalidMeasure", new Object[]{newValue, startMeasure, endMeasure});
		}
	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		if ( mboValue.getMbo().getMboSet("ASSET").getMbo(0) != null && mboValue.getMbo().getMboSet("ASSET").getMbo(0).getBoolean("ISLINEAR") ) {
			((SimulationRemote)mboValue.getMbo().getOwner()).calculateTotalWorkUnits();
		}
	}
}
