package com.ibm.swg.app.jobplan.virtual;

import java.rmi.RemoteException;

import psdi.common.parse.ParserServiceRemote;
import psdi.mbo.Mbo;
import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSetRemote;
import psdi.mbo.MboValue;
import psdi.server.MXServer;
import psdi.util.MXException;

public class FldSimulationMultiAssetLocCIAssetnum extends psdi.app.asset.FldAssetnum {

	public FldSimulationMultiAssetLocCIAssetnum(MboValue mbv)
			throws MXException {
		super(mbv);
		
		String[] targetKeys = {"ORGID","SITEID","ASSETNUM"};
		String[] sourceKeys = {"ORGID","SITEID","ASSETNUM"};
		setLookupKeyMapInOrder(targetKeys, sourceKeys);
	}

	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		
		Mbo jobplan = (Mbo) getMboValue().getMbo().getOwner().getOwner();
		MboSetRemote assetSet = mboValue.getMbo().getMboSet("ASSET");
		assetSet.reset();
		MboRemote asset = assetSet.getMbo(0);
		
		boolean mustApplyLinearCalculation = jobplan.getBoolean("DYNAMIC") && !jobplan.getBoolean("APPLYNONDYNAMICCALC");
		
		if ( mustApplyLinearCalculation && asset != null && asset.getBoolean("ISLINEAR") ) {
			getMboValue(SimulationRemote.TOTALWORKUNITS).setFlag(MboConstants.READONLY, true);
			
			getMboValue("STARTMEASURE").setFlag(MboConstants.READONLY, false);
			getMboValue("ENDMEASURE").setFlag(MboConstants.READONLY, false);
			getMboValue("STARTMEASUREUNITID").setFlag(MboConstants.READONLY, true);
			getMboValue("ENDMEASUREUNITID").setFlag(MboConstants.READONLY, true);
			
			getMboValue("STARTMEASUREUNITID").setValue(asset.getString("LINEARREFMETHOD.MEASUREUNITID"), NOACCESSCHECK);
			getMboValue("ENDMEASUREUNITID").setValue(asset.getString("LINEARREFMETHOD.MEASUREUNITID"), NOACCESSCHECK);
			getMboValue("STARTMEASURE").setValue(asset.getDouble("STARTMEASURE"));
			getMboValue("ENDMEASURE").setValue(asset.getDouble("ENDMEASURE"));
			
			
		} else {
			getMboValue(SimulationRemote.TOTALWORKUNITS).setFlag(MboConstants.READONLY, false);

			String def = getMboValue(SimulationRemote.TOTALWORKUNITS).getMboValueInfo().getDefaultValue();
			ParserServiceRemote parserService = (ParserServiceRemote)MXServer.getMXServer().lookup("PARSER");
			getMboValue(SimulationRemote.TOTALWORKUNITS).setValue(parserService.getDouble(def, mboValue.getMbo()));
			
			getMboValue("STARTMEASURE").setFlag(MboConstants.READONLY, true);
			getMboValue("ENDMEASURE").setFlag(MboConstants.READONLY, true);
			getMboValue("STARTMEASUREUNITID").setFlag(MboConstants.READONLY, true);
			getMboValue("ENDMEASUREUNITID").setFlag(MboConstants.READONLY, true);
			//getMboValue(SimulationRemote.TOTALWORKUNITS).setValue(getMboValue(SimulationRemote.TOTALWORKUNITS).getInitialValue().asDouble());
		}
	}
	
	@Override
	public void setValueFromLookup(MboRemote mbo, long accessModifier)
			throws MXException, RemoteException {
		super.setValueFromLookup(mbo, accessModifier);
		String[] targetKeys = {"STARTMEASURE", "ENDMEASURE", "STARTMEASUREUNITID","ENDMEASUREUNITID"};
		String[] sourceKeys = {"STARTMEASURE", "ENDMEASURE", "LINEARREFMETHOD.MEASUREUNITID", "LINEARREFMETHOD.MEASUREUNITID"};
		
		for(int i = 0; i < sourceKeys.length; i++ ) {
			getMboValue(targetKeys[i]).setValue(mbo.getString(sourceKeys[i]), NOACCESSCHECK | NOACTION);
		}
		
		MboRemote asset = mboValue.getMbo().getMboSet("ASSET").getMbo(0);
		Mbo jobplan = (Mbo) getMboValue().getMbo().getOwner().getOwner();
		boolean mustApplyLinearCalculation = jobplan.getBoolean("DYNAMIC") && !jobplan.getBoolean("APPLYNONDYNAMICCALC");
		
		if ( asset != null && asset.getBoolean("ISLINEAR") && mustApplyLinearCalculation ) {
			((SimulationRemote)mboValue.getMbo().getOwner()).calculateTotalWorkUnits();
		}		
	}
}
