package com.ibm.swg.app.jobplan.virtual;

import java.rmi.RemoteException;

import psdi.mbo.MAXTableDomain;
import psdi.mbo.MboValue;
import psdi.util.MXException;

public class FldSimulationMultiAssetLocCIUnitId extends MAXTableDomain {

	public FldSimulationMultiAssetLocCIUnitId(MboValue mbv) {
		super(mbv);
		try {
			if ( !mbv.getMbo().getOwner().isNull("JPNUM") ) {
				String unitsOfWork = mbv.getMbo().getOwner().getString("JOBPLAN.UNITSOFWORK");
				String sql = "measureunitid = '" + unitsOfWork + "' OR exists (SELECT * FROM conversion WHERE ( frommeasureunit = '" + unitsOfWork + "' AND measureunit.measureunitid = tomeasureunit) OR (measureunit.measureunitid = frommeasureunit AND tomeasureunit = '" + unitsOfWork + "'))";
				setRelationship("MEASUREUNIT", sql);
				setListCriteria(sql);
			} else {
				setRelationship("MEASUREUNIT", " (orgid = :orgid and siteid = :siteid)");
			}
		} catch (RemoteException e) {
		} catch (MXException e) {
		}
		
		String[] targetKeys = new String[]{mbv.getAttributeName()};
		String[] sourceKeys = new String[]{"MEASUREUNITID"};
		setLookupKeyMapInOrder(targetKeys, sourceKeys );
	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		if ( mboValue.getMbo().getMboSet("ASSET").getMbo(0) != null && mboValue.getMbo().getMboSet("ASSET").getMbo(0).getBoolean("ISLINEAR") ) {
			if ( !(getMboValue("ASSETNUM").isNull() || getMboValue("STARTMEASURE").isNull() || getMboValue("ENDMEASURE").isNull() || getMboValue("STARTMEASUREUNITID").isNull() || getMboValue("ENDMEASUREUNITID").isNull())) {
				((SimulationRemote)mboValue.getMbo().getOwner()).calculateTotalWorkUnits();	
			}
			
		}
	}

}
