package com.ibm.swg.app.jobplan.virtual;

import java.rmi.RemoteException;

import psdi.app.jobplan.JobPlanRemote;
import psdi.mbo.Mbo;
import psdi.mbo.MboRemote;
import psdi.mbo.MboServerInterface;
import psdi.mbo.MboSet;
import psdi.mbo.NonPersistentMboSet;
import psdi.util.MXException;


public class SimulationSet extends NonPersistentMboSet implements SimulationSetRemote {

	public SimulationSet(MboServerInterface ms) throws RemoteException {
		super(ms);
	}

	@Override
	protected Mbo getMboInstance(MboSet ms) throws MXException, RemoteException {
		return new Simulation(ms);
	}

	@Override
	public MboRemote setup() throws MXException, RemoteException {
		SimulationRemote res = (SimulationRemote) super.setup();
		res.applyJobPlan((JobPlanRemote) this.getOwner());
		return res;
	}
	
	@Override
	public void execute() throws MXException, RemoteException {
		SimulationRemote res = (SimulationRemote) getMbo(0);
		res.calculateDynamicJobPlan();
	}
}
