package com.ibm.swg.app.pm;

import java.rmi.RemoteException;

import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSetRemote;
import psdi.mbo.MboValue;
import psdi.util.MXException;

import com.ibm.swg.util.DJPConstants;

public class FldDJPPMAssetnum extends psdi.app.pm.FldPMAssetnum {

	public FldDJPPMAssetnum(MboValue mbv) throws MXException {
		super(mbv);
	}

	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		
		MboRemote asset = mboValue.getMbo().getMboSet("ASSET").getMbo(0);
		MboSetRemote pmSequences = mboValue.getMbo().getMboSet("PMSEQUENCE");
		
		for(MboRemote pmSeq = pmSequences.moveFirst(); pmSeq != null; pmSeq = pmSequences.moveNext()) {
			MboRemote jp =  pmSeq.getMboSet("PLUSCJOBPLAN").getMbo(0);
			boolean mustApplyLinearCalculation =  jp != null && jp.getBoolean("DYNAMIC") && !jp.getBoolean("APPLYNONDYNAMICCALC");
			if ( mustApplyLinearCalculation && asset != null && asset.getBoolean("ISLINEAR") ) {
				
				pmSeq.setFieldFlag(DJPConstants.TOTALWORKUNITS, MboConstants.READONLY, true);
				double start = getMboValue("STARTMEASURE").getDouble();
				double end =  getMboValue("ENDMEASURE").getDouble();
				
				pmSeq.setValue(DJPConstants.TOTALWORKUNITS, Math.abs(end - start), MboConstants.NOACCESSCHECK);
					
			} else {
				pmSeq.setFieldFlag(DJPConstants.TOTALWORKUNITS,MboConstants.READONLY, false);
			}
		}
		
		
	}
}
