package com.ibm.swg.app.pm;

import java.rmi.RemoteException;

import com.ibm.swg.util.DJPConstants;

import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSetRemote;
import psdi.mbo.MboValue;
import psdi.util.MXException;

public class FldDJPPMMeasure extends psdi.app.asset.FldMeasure {

	public FldDJPPMMeasure(MboValue mbv) throws MXException, RemoteException {
		super(mbv);
	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		MboSetRemote pmSequences = mboValue.getMbo().getMboSet("PMSEQUENCE");
		
		for(MboRemote pmSeq = pmSequences.moveFirst(); pmSeq != null; pmSeq = pmSequences.moveNext()) {
			MboRemote jp =  pmSeq.getMboSet("PLUSCJOBPLAN").getMbo(0);
			
			boolean mustApplyLinearCalculation =  jp != null && jp.getBoolean("DYNAMIC") && !jp.getBoolean("APPLYNONDYNAMICCALC");
			if ( mustApplyLinearCalculation ) {
				double start = getMboValue("STARTMEASURE").getDouble();
				double end =  getMboValue("ENDMEASURE").getDouble();

				pmSeq.setFieldFlag(DJPConstants.TOTALWORKUNITS, MboConstants.READONLY, true);
				pmSeq.setValue(DJPConstants.TOTALWORKUNITS,Math.abs(end - start), MboConstants.NOACCESSCHECK);
			}
		}
	}

}
