package com.ibm.swg.app.pm;

import java.rmi.RemoteException;

import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboValue;
import psdi.mbo.MboValueAdapter;
import psdi.mbo.Translate;
import psdi.util.MXException;

import com.ibm.swg.util.DJPConstants;

public class FldDJPPMSequenceTotalWorkUnits extends MboValueAdapter {


	public FldDJPPMSequenceTotalWorkUnits(MboValue mbv) {
		super(mbv);
	}
	
	@Override
	public void init() throws MXException, RemoteException {
		super.init();
		
		MboRemote pm = getMboValue().getMbo().getOwner();
		Translate t = getTranslator();
		if ( !t.toInternalString("PMSTATUS", pm.getString("STATUS")).equals("DRAFT")) {
			getMboValue().setFlag(READONLY, true);
			return;
		}
		
		MboRemote asset = pm.getMboSet("ASSET").getMbo(0);
		MboRemote jp =  mboValue.getMbo().getMboSet("PLUSCJOBPLAN").getMbo(0);
		boolean mustApplyLinearCalculation =  jp != null && jp.getBoolean("DYNAMIC") && !jp.getBoolean("APPLYNONDYNAMICCALC");
		if ( mustApplyLinearCalculation && asset != null && asset.getBoolean("ISLINEAR") ) {
			getMboValue(DJPConstants.TOTALWORKUNITS).setFlag(MboConstants.READONLY, true);
		} else {
			getMboValue(DJPConstants.TOTALWORKUNITS).setFlag(MboConstants.READONLY, false);
		}
	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
//		MboRemote pm = getMboValue().getMbo().getOwner();
		
//		String relationName = mboValue.getMbo().getThisMboSet().getRelationName();
//		if ( relationName.equals("MAINPMSEQUENCE")) {
//			MboSetRemote pmSeq = mboValue.getMbo().getOwner().getMboSet("PMSEQUENCE","PMSEQUENCE");
//			for(MboRemote mbo = pmSeq.moveFirst(); mbo != null; mbo = pmSeq.moveNext()) {
//				if (mbo.getInt("INTERVAL") == 1 ) {
//					mbo.setValue(DJPConstants.TOTALWORKUNITS, mboValue.getDouble(), NOACTION|NOSAVE|NOUPDATE);
//				}
//			}
//		} else {
//			if ( getMboValue("JPNUM").getString().equals(pm.getString("JPNUM"))) {
//				pm.getMboSet("MAINPMSEQUENCE","PMSEQUENCE").getMbo(0).setValue(DJPConstants.TOTALWORKUNITS, mboValue.getDouble(), NOACCESSCHECK|NOACTION|NOSAVE|NOUPDATE);
//			}	
//		}
//		if ( getMboValue().getMbo().getThisMboSet().getMboSetInfo().getObjectName().equals("WORKORDER") ) {
//			DJPWORemote wo = (DJPWORemote) getMboValue().getMbo();
//			wo.calculateDynamicJobPlan();
//		}
	}

}
