package com.ibm.swg.app.resourcelevels;

import java.rmi.RemoteException;

import psdi.mbo.Mbo;
import psdi.mbo.MboSet;
import psdi.util.MXApplicationException;
import psdi.util.MXException;
import psdi.util.logging.annotations.TracePrimary;

public class ResourceByLevel extends Mbo implements ResourceByLevelRemote {

	public ResourceByLevel(MboSet ms) throws RemoteException {
		super(ms);
	}
	
	@Override
	public void add() throws MXException, RemoteException {
		super.add();
		
		// ORGID is already added because of the orglevel
		ResourceLevelsRemote levelsOwner = (ResourceLevelsRemote) getOwner();
		setValue(RESOURCELEVELSNUM, levelsOwner.getResourceLevelsNum());
		
	}
	
	@Override
	@TracePrimary
	protected void save() throws MXException, RemoteException {
		if ( !isNull(LOWERTHRESHOLD) && !isNull(UPPERTHRESHOLD) && getDouble(LOWERTHRESHOLD) >= getDouble(UPPERTHRESHOLD) ) {
			throw new MXApplicationException("dynamicjobplan","thresholdInvalid");
		}
		
		ResourceLevelsRemote levelsOwner = (ResourceLevelsRemote) getOwner();
		if ( levelsOwner != null && (isNull(RESOURCELEVELSNUM) || !levelsOwner.getResourceLevelsNum().equals(getString(RESOURCELEVELSNUM)))) {
			setValue(RESOURCELEVELSNUM, levelsOwner.getResourceLevelsNum());
		}
		super.save();
	}

	@Override
	public double getQuantity() throws RemoteException, MXException {
		return getDouble(QUANTITY);
	}

	@Override
	public double getHours() throws RemoteException, MXException {
		return getDouble(HOURS);
	}
	
	@Override
	public double getLowerThreshold() throws RemoteException, MXException {
		return getDouble(LOWERTHRESHOLD);
	}

	@Override
	public double getUpperThreshold() throws RemoteException, MXException {
		return getDouble(UPPERTHRESHOLD);
	}

	@Override
	public String getOrgId() throws RemoteException, MXException {
		return getString(ORGID);
	}

}
