package com.ibm.swg.app.workorder;

import java.rmi.RemoteException;

import psdi.app.jobplan.JobPlanRemote;
import psdi.mbo.MAXTableDomain;
import psdi.mbo.Mbo;
import psdi.mbo.MboSetRemote;
import psdi.mbo.MboValue;
import psdi.mbo.Translate;
import psdi.util.MXException;

import com.ibm.swg.util.DJPConstants;

public class FldDJPWOUnitsOfWork extends MAXTableDomain {

	public FldDJPWOUnitsOfWork(MboValue mbv) {
		super(mbv);

		String[] targetKeys = new String[]{"UNITSOFWORK"};
		String[] sourceKeys = new String[]{"MEASUREUNITID"};
		setLookupKeyMapInOrder(targetKeys, sourceKeys );
	}
	
	@Override
	public void init() throws MXException, RemoteException {
		super.init();
		
		Mbo wo = (Mbo) getMboValue().getMbo();
		Translate t = wo.getTranslator();
		boolean isWAPPR = t.toInternalString("WOSTATUS", wo.getString("STATUS")).equals("WAPPR");
		
		
		mboValue.setFlag(READONLY, !isWAPPR || wo.isNull("JPNUM") || !wo.getBoolean("JOBPLAN." + DJPConstants.DYNAMIC));

	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		DJPWORemote wo = (DJPWORemote) mboValue.getMbo();
		wo.calculateDynamicJobPlan();
	}

	@Override
	public void validate() throws MXException, RemoteException {
		restrict();
		super.validate();
	}
	
	private void restrict() {
		try {
			if ( !mboValue.getMbo().isNull("JPNUM") ) {
				JobPlanRemote jobPlan = (JobPlanRemote) mboValue.getMbo().getMboSet("$JOBPLAN","JOBPLAN","orgid = :orgid AND siteid = :siteid AND jpnum = :jpnum and :PLUSCJPREVNUM =  PLUSCREVNUM").getMbo(0);
				if ( jobPlan == null ) jobPlan = (JobPlanRemote) mboValue.getMbo().getMboSet("$JOBPLAN","JOBPLAN","orgid = :orgid AND jpnum = :jpnum and :PLUSCJPREVNUM =  PLUSCREVNUM").getMbo(0);
				if ( jobPlan == null ) jobPlan = (JobPlanRemote) mboValue.getMbo().getMboSet("$JOBPLAN","JOBPLAN","jpnum = :jpnum and :PLUSCJPREVNUM =  PLUSCREVNUM").getMbo(0);
				if ( jobPlan == null ) {
					setRelationship("MEASUREUNIT", " (orgid = :orgid and siteid = :siteid) or (orgid is null)");
				} else {
					String unitsOfWork = jobPlan.getString(DJPConstants.UNITSOFWORK);
					String sql = "measureunitid = '" + unitsOfWork + "' OR exists (SELECT * FROM conversion WHERE ( frommeasureunit = '" + unitsOfWork + "' AND measureunit.measureunitid = tomeasureunit) OR (measureunit.measureunitid = frommeasureunit AND tomeasureunit = '" + unitsOfWork + "'))";
					setRelationship("MEASUREUNIT", sql);
					setListCriteria(sql);	
				}
			} else {
				setRelationship("MEASUREUNIT", " (orgid = :orgid and siteid = :siteid) or (orgid is null)");
			}
		} catch (RemoteException e) {
		} catch (MXException e) {
		}

	}
	@Override
	public MboSetRemote getList() throws MXException, RemoteException {
		restrict();
		return super.getList();
	}
	
}
