package com.ibm.swg.util;

public interface DJPConstants {

	// On JOBPLAN, JOBTASK, JOBITEM (JOBLABOR, JOBMATERIAL, JOBTOOL, JOBSERVICE)
	public static final String CALCAPPLYTO = "CALCAPPLYTO";
	// On JOBPLAN, JOBTASK, JOBITEM (JOBLABOR, JOBMATERIAL, JOBTOOL, JOBSERVICE)
	public static final String CALCLEVEL = "CALCLEVEL";
	// On JOBPLAN, JOBTASK, JOBITEM (JOBLABOR, JOBMATERIAL, JOBTOOL, JOBSERVICE)
	public static final String CALCMETHOD = "CALCMETHOD";
	
	// On JOBPLAN, JOBTASK, JOBLABOR, JOBITEM (JOBLABOR, JOBMATERIAL, JOBTOOL, JOBSERVICE)
	public static final String CALCEXPRESSION = "CALCEXPRESSION";
	
	// On JOBLABOR, JBITEM (JOBTOOL)
	public static final String CALCEXPRESSIONHOURS = "CALCEXPRESSIONHOURS";
	
	// On JOBPLAN
	public static final String UNITSOFWORKMULTIPLIER = "UNITSOFWORKMULTIPLIER";
	public static final String DYNAMIC = "DYNAMIC";
	public static final String APPLYNONDYNAMICCALC = "APPLYNONDYNAMICCALC";
	
	
	// On JOBPLAN and WORKORDER
	public static final String UNITSOFWORK   = "UNITSOFWORK";
	
	// On JOBPLAN, PM, WORKORDER, MULTIASSETLOCCI, ROUTE_STOP
	public static final String TOTALWORKUNITS = "TOTALWORKUNITS";	
		
	public static final String JOBTASKID = "JOBTASKID";
	public static final String JOBITEMID = "JOBITEMID";
	public static final String JOBLABORID = "JOBLABORID";
		
	public static final String[] attributesToCopyForTask 		= {JOBTASKID};
	public static final String[] attributesToCopyForLabor		= {JOBLABORID};
	public static final String[] attributesToCopyForItem		= {JOBITEMID};
	
	
	// Domain values for calculation type 
	public static final String CALCMETHOD_STATIC = "STATIC";
	public static final String CALCMETHOD_PROPORTIONAL = "PROPORTIONAL";
	public static final String CALCMETHOD_LEVEL = "LEVEL";
	public static final Object CALCMETHOD_PROPORTIONAL_ATTRIBUTE = "ATTR_PROP";
	public static final String CALCMETHOD_LEVEL_ATTRIBUTE = "ATTR_LVL";
	

	public static enum CalcApplyTo {
		QUANTITY,
		HOURS, 
		BOTH;
		
		public String toString() {
			return this == QUANTITY ? "QUANTITY" : this == HOURS ? "HOURS" : this == BOTH ? "BOTH" : null;
		}
		
		public static CalcApplyTo fromStringTo(String val) {
			return val.equalsIgnoreCase(CalcApplyTo.QUANTITY.toString()) ? CalcApplyTo.QUANTITY :
				val.equalsIgnoreCase(CalcApplyTo.HOURS.toString()) ? CalcApplyTo.HOURS :
					val.equalsIgnoreCase(CalcApplyTo.BOTH.toString()) ? CalcApplyTo.BOTH :
						null;
		}
	}

		
}
