package com.ibm.swg.webclient.beans.jobplan;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Map;

import psdi.mbo.MboConstants;
import psdi.mbo.MboSetRemote;
import psdi.mbo.NonPersistentMboSetRemote;
import psdi.util.MXException;
import psdi.webclient.system.beans.DataBean;
import psdi.webclient.system.controller.ControlInstance;
import psdi.webclient.system.controller.WebClientEvent;

import com.ibm.swg.app.jobplan.virtual.DynamicExpressionBuilderRemote;
import com.ibm.swg.app.jobplan.virtual.DynamicExpressionBuilderSetRemote;

public class DynamicExpressionBuilderBean extends DataBean {

	private static Map<String,String> functions;
	static {
		
		functions = new HashMap<String,String>();
			
		functions.put("abs"  , "Math.abs(x)");
		functions.put("acos" , "Math.acos(x)");
		functions.put("cos"  , "Math.cos(x)");
		functions.put("asin" , "Math.asin(x)");
		functions.put("sin"  , "Math.sin(x)");
		functions.put("atan" , "Math.atan(x)");
		functions.put("atan2", "Math.atan2(x,y)");
		functions.put("tan"  , "Math.tan(x)");
		functions.put("ceil" , "Math.ceil(x)");
		functions.put("floor", "Math.floor(x)");
		functions.put("round", "Math.round(x)");
		functions.put("max"  , "Math.max(x,y)");
		functions.put("min"  , "Math.min(x,y)");
		functions.put("pow"  , "Math.pow(x,y)");
		functions.put("exp"  , "Math.exp(x)");
		functions.put("log"  , "Math.log(x)");
		functions.put("sqrt" , "Math.sqrt(x)");
	}
	
	protected void initialize() throws MXException, RemoteException
	{
		super.initialize();
	}
	
    /**
     * Get the current ExpressionBuilderSet and set the attached attribute
     */
    protected MboSetRemote getMboSetRemote() throws MXException, RemoteException
    {
        DynamicExpressionBuilderSetRemote msr = (DynamicExpressionBuilderSetRemote)super.getMboSetRemote();
        ControlInstance sourceControl = app.getWebClientSession().getCurrentEvent().getSourceControlInstance();
        String dataAtt = sourceControl.getProperty("dataattribute");
        msr.setObjectAttribute(dataAtt);
        return msr;
    }
	
	synchronized public int execute() throws MXException, RemoteException
	{
		if (mboSetRemote != null)
		{	
			((NonPersistentMboSetRemote)mboSetRemote).execute();
			
			clientSession.addMXWarnings(mboSetRemote.getWarnings());
		}
		
		return EVENT_HANDLED;
	}
	
	private boolean isMath(String function) {
		return functions.keySet().contains(function.toLowerCase());
	}
	
	public int addToken() throws MXException, RemoteException {
		WebClientEvent event = clientSession.getCurrentEvent();
		String eventValue = event.getValueString();
		
		String val = getString(DynamicExpressionBuilderRemote.CALCEXPRESSION);
		val += isMath(eventValue) ? functions.get(eventValue) : eventValue;
		
		setValue(DynamicExpressionBuilderRemote.CALCEXPRESSION, val, MboConstants.NOVALIDATION);
		return EVENT_HANDLED;
	}
	
	public int dynexpbuilder_validate() throws MXException, RemoteException {
		return EVENT_HANDLED;
	}
	
	public int dynexpbuilder_simulate() throws MXException, RemoteException {
		return EVENT_HANDLED;
	}
}
