package com.ibm.swg.webclient.beans.workorder;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Map;

import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSetRemote;
import psdi.util.MXException;
import psdi.webclient.system.controller.WebClientEvent;

import com.ibm.swg.app.workorder.DJPWORemote;

public class SimulationBean extends com.ibm.swg.webclient.beans.jobplan.SimulationBean {

	Map<MboRemote,MboRemote> woMultiAssets;
	
	public SimulationBean() {
		super();
		
		woMultiAssets = new HashMap<MboRemote, MboRemote>();
	}
	
		
	@Override
	protected void initialize() throws MXException, RemoteException {
		super.initialize();
		
		MboRemote simulation = getMbo();
		MboRemote wo = clientSession.getDataBean("MAINRECORD").getMbo();
		
		MboSetRemote multi = wo.getMboSet("MULTIASSETLOCCI");
		MboSetRemote multiSimulation = simulation.getMboSet("ALLMULTIASSETLOCCI");
		for(MboRemote row = multi.moveFirst(); row != null; row = multi.moveNext()) {
			MboRemote simulRow = multiSimulation.add();
//			woMultiAssets.put(row, simulRow);
			woMultiAssets.put(simulRow, row);

			if ( !row.isNull("ASSETNUM")) simulRow.setValue("ASSETNUM", row.getMboSet("ASSET").getMbo(0));
			if ( !row.isNull("LOCATION")) simulRow.setValue("LOCATION", row.getMboSet("LOCATION").getMbo(0));
			if ( !row.isNull("CINUM")) simulRow.setValue("CINUM", row.getMboSet("CI").getMbo(0));
			
			if ( !row.isNull("TOTALWORKUNITS")) simulRow.setValue("TOTALWORKUNITS", row.getString("TOTALWORKUNITS"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("STARTMEASURE")) simulRow.setValue("STARTMEASURE", row.getString("STARTMEASURE"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("STARTMEASUREUNITID")) simulRow.setValue("STARTMEASUREUNITID", row.getString("STARTMEASUREUNITID"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("ENDMEASURE")) simulRow.setValue("ENDMEASURE", row.getString("ENDMEASURE"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("ENDMEASUREUNITID")) simulRow.setValue("ENDMEASUREUNITID", row.getString("ENDMEASUREUNITID"), MboConstants.NOACCESSCHECK);
		}
		if ( wo.getMboSet("LINEARRELATED").getMbo(0) != null ) {
			MboRemote row = wo.getMboSet("LINEARRELATED").getMbo(0);
			MboRemote simulRow = multiSimulation.add();
//			woMultiAssets.put(row, simulRow);
			woMultiAssets.put(simulRow, row);

			if ( !row.isNull("ASSETNUM")) simulRow.setValue("ASSETNUM", row.getMboSet("ASSET").getMbo(0));
			if ( !row.isNull("LOCATION")) simulRow.setValue("LOCATION", row.getMboSet("LOCATION").getMbo(0));
			if ( !row.isNull("CINUM")) simulRow.setValue("CINUM", row.getMboSet("CI").getMbo(0));
			
			if ( !row.isNull("TOTALWORKUNITS")) simulRow.setValue("TOTALWORKUNITS", row.getString("TOTALWORKUNITS"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("STARTMEASURE")) simulRow.setValue("STARTMEASURE", row.getString("STARTMEASURE"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("STARTMEASUREUNITID")) simulRow.setValue("STARTMEASUREUNITID", row.getString("STARTMEASUREUNITID"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("ENDMEASURE")) simulRow.setValue("ENDMEASURE", row.getString("ENDMEASURE"), MboConstants.NOACCESSCHECK);
			if ( !row.isNull("ENDMEASUREUNITID")) simulRow.setValue("ENDMEASUREUNITID", row.getString("ENDMEASUREUNITID"), MboConstants.NOACCESSCHECK);
		}
	}
	
	public int UPDATEWO() throws MXException, RemoteException {
		MboRemote wo = clientSession.getDataBean("MAINRECORD").getMbo();
		MboSetRemote multiAssets = wo.getMboSet("MULTIASSETLOCCI");
		
		MboRemote simulation = getMbo();
		MboSetRemote multiSimulation = simulation.getMboSet("ALLMULTIASSETLOCCI");
		
		boolean primaryDeleted = false;
		
		for(MboRemote multi = multiSimulation.moveFirst(); multi != null; multi = multiSimulation.moveNext() ) {
			MboRemote altered = woMultiAssets.get(multi);
			if ( altered != null ){
				if ( multi.toBeDeleted() ) {
					if ( altered.getBoolean("ISPRIMARY")) {
						primaryDeleted = true;
						wo.setValueNull("ASSETNUM");
						wo.setValueNull("LOCATION");
						wo.setValueNull("CINUM");
					}
					altered.delete();
				} else {
					altered.setValue("ASSETNUM", multi.getString("ASSETNUM"));
					altered.setValue("LOCATION", multi.getString("LOCATION"));
					altered.setValue("CINUM", multi.getString("CINUM"));
					altered.setValue("TOTALWORKUNITS", multi.getDouble("TOTALWORKUNITS"), MboConstants.NOACCESSCHECK);
					if ( !altered.getMboValueData("STARTMEASURE").isReadOnly() ) {
						altered.setValue("STARTMEASURE", multi.getString("STARTMEASURE"));
					}
					if ( !altered.getMboValueData("ENDMEASURE").isReadOnly() ) {
						altered.setValue("ENDMEASURE", multi.getString("ENDMEASURE"));
					}
					if ( altered.getBoolean("ISPRIMARY")) {
						wo.setValue("ASSETNUM", multi.getString("ASSETNUM"));
						wo.setValue("LOCATION", multi.getString("LOCATION"));
						wo.setValue("CINUM", multi.getString("CINUM"));
					}
				}	
			}
		}
		
		for(MboRemote multi = multiSimulation.moveFirst(); multi != null; multi = multiSimulation.moveNext() ) {
			MboRemote altered = woMultiAssets.get(multi);
			if ( altered == null ) {	// user added this line, we have to add it in the wo multiassetlocci
				if ( primaryDeleted ) {
					wo.setValue("ASSETNUM", multi.getString("ASSETNUM"));
					wo.setValue("LOCATION", multi.getString("LOCATION"));
					wo.setValue("CINUM", multi.getString("CINUM"));
					MboRemote linear = wo.getMboSet("LINEARRELATED").getMbo(0);
					if ( linear != null ) {
						linear.setValue("TOTALWORKUNITS", multi.getDouble("TOTALWORKUNITS"), MboConstants.NOACCESSCHECK);
						linear.setValue("STARTMEASURE", multi.getString("STARTMEASURE"));
						linear.setValue("ENDMEASURE", multi.getString("ENDMEASURE"));
					}
				} else {
					MboRemote tmp = multiAssets.add();
					tmp.setValue("ASSETNUM", multi.getString("ASSETNUM"));
					tmp.setValue("LOCATION", multi.getString("LOCATION"));
					tmp.setValue("CINUM", multi.getString("CINUM"));
					tmp.setValue("TOTALWORKUNITS", multi.getDouble("TOTALWORKUNITS"), MboConstants.NOACCESSCHECK);
					tmp.setValue("STARTMEASURE", multi.getString("STARTMEASURE"));
					tmp.setValue("ENDMEASURE", multi.getString("ENDMEASURE"));
				}
			} 
		}
		
		((DJPWORemote)wo).calculateDynamicJobPlan();
		clientSession.queueEvent(new WebClientEvent("dialogclose", this.getId(), null, clientSession));
		clientSession.getDataBean("MAINRECORD").fireDataChangedEvent();
		
		return EVENT_HANDLED;
	}
}
