package com.ibm.swg.app.jobplan;

import java.rmi.RemoteException;

import com.ibm.swg.util.DJPConstants;
import com.ibm.swg.util.DynamicJobPlanHelper;

import psdi.mbo.Mbo;
import psdi.mbo.MboValue;
import psdi.mbo.StatefulMboRemote;
import psdi.mbo.SynonymDomain;
import psdi.mbo.Translate;
import psdi.util.MXException;

public class FldJobCalcApplyTo extends SynonymDomain implements DJPConstants {


	public FldJobCalcApplyTo(MboValue mbv) {
		super(mbv);
		setDomainId("CALCAPPLYTO");
//		setConditionalValWhere(":calcmethod = 'BOTH' or maxvalue IN('QUANTITY','HOURS')");
	}

	@Override
	public void init() throws MXException, RemoteException {
		super.init();
		
		MboValue mbv = getMboValue();
		Mbo mbo = mbv.getMbo();	// could be a JOBTASK, JLOBLABOR, JOBMATERIAL, JOBSERVICE, JOBTOOL, WPLABOR, WOACTIVITY, WPLABOR, WPMATERIAL, WPSERVICE, WPTOOL 
		String objectName = mbo.getThisMboSet().getMboSetInfo().getObjectName();
		Translate t = mbo.getTranslator();
		
		if ( objectName.equals("JOBTASK") ) {
			if ( mbv.isNull() || t.toInternalString("CALCAPPLYTO", mbv.getString()).equals("QUANTITY")) {
				mbv.setValue(t.toExternalDefaultValue("CALCAPPLYTO", "HOURS", mbo));
			}
			mbv.setFlag(READONLY, true);
		} else if ( objectName.equals("WPMATERIAL") || objectName.equals("JOBMATERIAL")) {
			if ( mbv.isNull() || t.toInternalString("CALCAPPLYTO", mbv.getString()).equals("HOURS")) {
				mbv.setValue(t.toExternalDefaultValue("CALCAPPLYTO", "QUANTITY", mbo));
			}
			mbv.setFlag(READONLY, true);
		}

		if ( mbv.isFlagSet(READONLY) ) return;	// already set : we don't care about parent status
		
		if ( !(mbo instanceof StatefulMboRemote)) return;
		StatefulMboRemote parentMbo = (StatefulMboRemote) mbo.getOwner();	// could be a WORKORDER or JOBPLAN
		
		if ( parentMbo == null ) return;
		
		boolean cond = parentMbo.isBasedOn("JOBPLAN") && parentMbo.getInternalStatus().equals("ACTIVE");
		mbv.setFlag(READONLY, cond);
	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		DynamicJobPlanHelper.onJobResourceMethodchanged(mboValue.getMbo());
		
		getMboValue(DJPConstants.CALCLEVEL).setValueNull(NOACCESSCHECK);
	}
}
