package com.ibm.swg.app.jobplan;

import java.rmi.RemoteException;

import com.ibm.swg.util.DJPConstants;

import psdi.mbo.MAXTableDomain;
import psdi.mbo.Mbo;
import psdi.mbo.MboValue;
import psdi.mbo.StatefulMboRemote;
import psdi.util.MXException;

public class FldJobCalcAttribute extends MAXTableDomain {

	public FldJobCalcAttribute(MboValue mbv) {
		super(mbv);
		setRelationship("ASSETATTRIBUTE", "");
		
		String[] targetKeys = {"ASSETATTRID"};
		String[] sourceKeys = {"ASSETATTRID"};
		setLookupKeyMapInOrder(targetKeys, sourceKeys);
		
	}
	
	@Override
	public void init() throws MXException, RemoteException {
		super.init();
		
		
		MboValue mbv = getMboValue();
		Mbo mbo = mbv.getMbo();	// could be a JOBPLAN, JOBTASK, JLOBLABOR, JOBMATERIAL, JOBSERVICE, JOBTOOL, WPLABOR, WOACTIVITY, WPLABOR, WPMATERIAL, WPSERVICE, WPTOOL
		StatefulMboRemote parentMbo;
		
		if ( !mbo.isBasedOn("JOBPLAN") && mbo instanceof StatefulMboRemote) {
			parentMbo = (StatefulMboRemote) mbo.getOwner().getOwner();	// could be a WORKORDER or JOBPLAN
		} else if ( mbo instanceof StatefulMboRemote ) {
			parentMbo = (StatefulMboRemote) mbo;
		} else return;
		 
		
		if ( parentMbo == null ) return;
		
		boolean cond = parentMbo.isBasedOn("JOBPLAN") && parentMbo.getInternalStatus().equals("ACTIVE");
//		cond |= parentMbo.isBasedOn("WORKORDER") && !parentMbo.getInternalStatus().equals("WAPPR");
//		cond |= parentMbo.isBasedOn("WOACTIVITY") && !parentMbo.getInternalStatus().equals("WAPPR");
		cond |= !getMboValue(DJPConstants.CALCMETHOD).getString().equals(DJPConstants.CALCMETHOD_LEVEL_ATTRIBUTE)&& !getMboValue(DJPConstants.CALCMETHOD).getString().equals(DJPConstants.CALCMETHOD_PROPORTIONAL_ATTRIBUTE);

		mbv.setFlag(READONLY, cond);
		mbv.setFlag(REQUIRED,  getMboValue(DJPConstants.CALCMETHOD).getString().equals(DJPConstants.CALCMETHOD_LEVEL_ATTRIBUTE));
		mbv.setFlag(REQUIRED, mbv.isFlagSet(REQUIRED) ||  getMboValue(DJPConstants.CALCMETHOD).getString().equals(DJPConstants.CALCMETHOD_PROPORTIONAL_ATTRIBUTE));
//		
	}

}
