package com.ibm.swg.app.jobplan;

import java.rmi.RemoteException;

import psdi.mbo.Mbo;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSet;
import psdi.util.MXApplicationException;
import psdi.util.MXException;

public class JobResourceAttribute extends Mbo implements JobResourceAttributeRemote {

	
	public JobResourceAttribute(MboSet ms) throws RemoteException {
		super(ms);
	}
	
	@Override
	public void add() throws MXException, RemoteException {
		super.add();
		
		MboRemote owner = getOwner();
		
		setValue(OBJECTNAME, owner.getThisMboSet().getMboSetInfo().getObjectName());
		setValue(JOBRESOURCEID, owner.getUniqueIDValue());
		
	}

	@Override
	public void canDelete() throws MXException, RemoteException {
		super.canDelete();
		if ( getOwner().getOwner().getString("STATUS").equals("ACTIVE")) {
			throw new MXApplicationException("system","cannotAdd");
		}
	}
}
