package com.ibm.swg.app.jobplan;

import java.rmi.RemoteException;

import javax.script.ScriptException;

import com.ibm.swg.util.DJPConstants;
import com.ibm.swg.util.PreparedScript;

import psdi.mbo.MboSetRemote;
import psdi.mbo.MboValue;
import psdi.mbo.MboValueAdapter;
import psdi.server.MXServer;
import psdi.util.MXApplicationException;
import psdi.util.MXException;

public class FldJobCalcExpression extends MboValueAdapter implements DJPConstants {

	
	public FldJobCalcExpression(MboValue mbv) {
		super(mbv);
//		setRelationship("ASSETATTRIBUTE", "");
//		
//		String[] targetKeys = {"EXPRESSION"};
//		String[] sourceKeys = {"ASSETATTRID"};
//		setLookupKeyMapInOrder(targetKeys, sourceKeys);
	}

	
	@Override
	public void validate() throws MXException, RemoteException {

		String scriptAsText = mboValue.getString();
		PreparedScript<Double> script = null;
		try {
			script = new PreparedScript<Double>(scriptAsText);
		} catch (IllegalArgumentException e ) {
			throw new MXApplicationException("dynamicjobplan","invalidExpression",e);
		}
		
		//script.setParameterValue(HOURS_TAG, 1.0);
		//script.setParameterValue(QUANTITY_TAG, 1.0);
		
		MboSetRemote assetAttributes = MXServer.getMXServer().getMboSet("ASSETATTRIBUTE", mboValue.getMbo().getUserInfo());
		MboSetRemote featureAttributes = MXServer.getMXServer().getMboSet("ASSETFEATURESPEC", mboValue.getMbo().getUserInfo());
		
		featureAttributes.setQbeExactMatch(true);
		assetAttributes.setQbeExactMatch(true);
		
		for(String param : script.getParametersName()) {
			if ( script.getParameter(param) == null ) {
				
				if ( script.paramIsFeature(param)) {
					featureAttributes.resetQbe();
					featureAttributes.setQbe("FEATURE", param.split(":")[0]);
					featureAttributes.setQbe("ASSETATTRID", param.split(":")[1]);
					if ( featureAttributes.count() != 0 ) {
						script.setParameterValue(param, 1.0);
					} else {
						throw new MXApplicationException("dynamicjobplan","invalidAttribute",new Object[]{param});
					}
				} else {
					assetAttributes.resetQbe();
					assetAttributes.setQbe("ASSETATTRID",param);
					if ( assetAttributes.count() != 0 ) {
						script.setParameterValue(param, 1.0);
					} else {
						throw new MXApplicationException("dynamicjobplan","invalidAttribute",new Object[]{param});
					}
				}
				
			}
		}
		assetAttributes.close();
		
		try {
			script.eval();
//			Class<?> clazz = res.getClass();
//			if ( !(	clazz.equals(Double.class) || 
//					clazz.equals(Integer.class) || 
//					clazz.equals(Long.class) ||
//					clazz.equals(Short.class) ||
//					clazz.equals(Float.class) ||
//					clazz.equals(BigDecimal.class))) {
//				throw new MXApplicationException("dynamicjobplan","invalidResultType", new Object[]{clazz});
//			}
		} catch (ScriptException e1) {
			e1.printStackTrace();
			throw new MXApplicationException("dynamicjobplan","invalidExpression", e1);
		}
		
	}
	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
	}
	
	
}
