package com.ibm.swg.app.jobplan.virtual;

import java.rmi.RemoteException;

import com.ibm.swg.util.DJPConstants;

import psdi.mbo.MAXTableDomain;
import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboValue;
import psdi.util.MXException;

public class FldSimulationAssetnum extends MAXTableDomain {

	public FldSimulationAssetnum(MboValue mbv) {
		super(mbv);
		
		setRelationship("ASSET", "assetnum = :assetnum");// AND (:siteid = '' or siteid = :siteid)");
		//setListCriteria(":siteid = '' or siteid = :siteid");
		String[] targetKeys = {"ASSETNUM","ORGID","SITEID"};//,"STARTMEASURE", "ENDMEASURE", "STARTMEASUREUNITID","ENDMEASUREUNITID"};
		String[] sourceKeys = {"ASSETNUM","ORGID","SITEID"};//,"STARTMEASURE", "ENDMEASURE", "LINEARREFMETHOD.MEASUREUNITID", "LINEARREFMETHOD.MEASUREUNITID"};
		setLookupKeyMapInOrder(targetKeys, sourceKeys);
	}

	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		boolean jpApplyLinear = !mboValue.getMbo().getOwner().getBoolean(DJPConstants.APPLYNONDYNAMICCALC);
		if ( mboValue.getMbo().getMboSet("ASSET").getMbo(0) != null && mboValue.getMbo().getMboSet("ASSET").getMbo(0).getBoolean("ISLINEAR") && jpApplyLinear) {
			getMboValue(SimulationRemote.TOTALWORKUNITS).setFlag(MboConstants.READONLY, true);
		} else {
			getMboValue(SimulationRemote.TOTALWORKUNITS).setFlag(MboConstants.READONLY, false);
		}
	}
	
	@Override
	public void setValueFromLookup(MboRemote mbo, long accessModifier)
			throws MXException, RemoteException {
		super.setValueFromLookup(mbo, accessModifier);
		String[] targetKeys = {"STARTMEASURE", "ENDMEASURE", "STARTMEASUREUNITID","ENDMEASUREUNITID"};
		String[] sourceKeys = {"STARTMEASURE", "ENDMEASURE", "LINEARREFMETHOD.MEASUREUNITID", "LINEARREFMETHOD.MEASUREUNITID"};
		
		for(int i = 0; i < sourceKeys.length; i++ ) {
			getMboValue(targetKeys[i]).setValue(mbo.getString(sourceKeys[i]), NOACCESSCHECK | NOACTION);
		}
		if ( mboValue.getMbo().getMboSet("ASSET").getMbo(0) != null && mboValue.getMbo().getMboSet("ASSET").getMbo(0).getBoolean("ISLINEAR") ) {
			((SimulationRemote)mboValue.getMbo()).calculateTotalWorkUnits();
		}		
	}
	
}
