package com.ibm.swg.app.jobplan.virtual;

import java.rmi.RemoteException;

import psdi.app.jobplan.JobPlanRemote;
import psdi.mbo.MboRemote;
import psdi.mbo.NonPersistentMboRemote;
import psdi.util.MXException;

public interface SimulationRemote extends NonPersistentMboRemote {
	
	public static final String ESTDUR 				= "ESTDUR";
	public static final String JPNUM 				= "JPNUM";
	public static final String PLUSCREVNUM 		= "PLUSCREVNUM";
	public static final String ORGID 				= "ORGID";
	public static final String SITEID 				= "SITEID";
	public static final String TOTALWORKUNITS 		= "TOTALWORKUNITS";
	
	public static final String STARTMEASURE 		= "STARTMEASURE";
	public static final String ENDMEASURE 			= "ENDMEASURE";
	public static final String STARTMEASUREUNITID 	= "STARTMEASUREUNITID";
	public static final String ENDMEASUREUNITID 	= "ENDMEASUREUNITID";
	
	public static final String TASKS 			= "TASKS";
	public static final String LABORS 			= "LABORS";
	public static final String MATERIALS 		= "MATERIALS";
	public static final String SERVICES 		= "SERVICES";
	public static final String TOOLS 			= "TOOLS";
	
	public static final String TYPE = "TYPE";
	public static final String JOBRESOURCEID = "JOBRESOURCEID";
	
	public void applyJobPlan(JobPlanRemote jobplan) throws RemoteException, MXException;

	public void calculateDynamicJobPlan() throws RemoteException, MXException;
	
	public void calculateTotalWorkUnits() throws RemoteException, MXException;

	void calculateTotalWorkUnitsFor(MboRemote multiAssetLocCI, String unitOfWork)
			throws RemoteException, MXException;
}
