package com.ibm.swg.app.resourcelevels;

import java.rmi.RemoteException;

import psdi.mbo.Mbo;
import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSet;
import psdi.util.MXException;

public class ResourceLevels extends Mbo implements ResourceLevelsRemote {

	
	public ResourceLevels(MboSet ms) throws RemoteException {
		super(ms);
	}

	@Override
	public String getResourceLevelsNum() throws RemoteException, MXException {
		return getString(RESOURCELEVELSNUM);
	}
	
	@Override
	public void delete(long accessModifier) throws MXException, RemoteException {
		super.delete(accessModifier);
		this.getLevels().deleteAll(accessModifier);
	}

	@Override
	public ResourceByLevelSetRemote getLevels() throws RemoteException,
			MXException {
		return (ResourceByLevelSetRemote) getMboSet(LEVELS);
	}

	@Override
	public MboRemote duplicate() throws MXException, RemoteException {
		ResourceLevels res = (ResourceLevels) getThisMboSet().add();
		String[] attrs = {SOURCE,DESCRIPTION, TYPE};
		String[] levelAttrs = {ResourceByLevelRemote.RESOURCELEVELSNUM,ResourceByLevelRemote.ORGID, ResourceByLevelRemote.LOWERTHRESHOLD, ResourceByLevelRemote.UPPERTHRESHOLD, ResourceByLevelRemote.QUANTITY, ResourceByLevelRemote.HOURS};
		res.copyValue(this, attrs, attrs, MboConstants.NONE);
		ResourceByLevelSetRemote levels = res.getLevels();
		
		ResourceByLevelSetRemote tmp = this.getLevels();
		for(MboRemote level = tmp.moveFirst(); level != null; level = tmp.moveNext()) {
			ResourceByLevelRemote l = (ResourceByLevelRemote) levels.add();
			l.copyValue(level, levelAttrs, levelAttrs, MboConstants.NONE);
		}
		
		return res;
	}
	
	@Override
	public ResourceByLevelRemote getLevelForValue(double value)
			throws RemoteException, MXException {
		return getLevels().getLevelForValue(value);
	}

}
