package com.ibm.swg.app.workorder;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Map;

import com.ibm.swg.util.DJPConstants;

import psdi.app.jobplan.JobPlan;
import psdi.app.workorder.WOSetRemote;
import psdi.mbo.MboConstants;
import psdi.mbo.MboRemote;
import psdi.mbo.MboSetRemote;
import psdi.mbo.MboValue;
import psdi.util.MXException;


public class FldWOJobPlan extends psdi.app.workorder.FldWOJobPlan {

	public FldWOJobPlan(MboValue mbv) throws MXException {
		super(mbv);
	}

	
	@Override
	public void action() throws MXException, RemoteException {
		super.action();
		
		// Null value set on JPNUM : do nothing
		// Maybe we will have to clean the already calculated fields
		if ( getMboValue().isNull() ) {
			return;
		}
		
		// Retrieve the job plan associated to the main WO
		MboSetRemote jobPlanSet = getMboValue().getMbo().getMboSet(WOSetRemote.JOBPLAN);
		jobPlanSet.reset();
		MboRemote jobPlan = jobPlanSet.getMbo(0);
		
		// Retrieve all the job task of the job plan, indexed by their TASKID
		MboSetRemote operations = ((JobPlan)jobPlan).getJobPlanComponentSet(psdi.app.jobplan.JobPlanSet.JOBTASK, getMboValue("ORGID").getString(), getMboValue("SITEID").getString());
		Map<Integer, MboRemote> dataToCopy = new HashMap<Integer,MboRemote>();
		for(MboRemote operation = operations.moveFirst(); operation != null; operation = operations.moveNext()) {
			dataToCopy.put(operation.getInt("JPTASK"), operation);
		}
		// Retrieve all the sub workorder or sub task created during the super.action()
		MboSetRemote woTasks = getMboValue().getMbo().getMboSet(WOSetRemote.WOACTIVITY);
//		MboSetRemote children = getMboValue().getMbo().getMboSet(WOSetRemote.SHOWCHILDREN);
		
		// For each sub workorder, or sub task, find the associated job task (based on TASKID) and copy the CALCMETHOD, CALCLEVEL, CALCATTRIBUTE, CALCCOEFF
		for(MboRemote task = woTasks.moveFirst(); task != null; task = woTasks.moveNext() ) {
			if ( !task.isNull("TASKID") && dataToCopy.containsKey(task.getInt("TASKID"))) {
				task.copyValue(dataToCopy.get(task.getInt("TASKID")), DJPConstants.attributesToCopyForTask, DJPConstants.attributesToCopyForTask, MboConstants.NOACCESSCHECK);
			}
		}
		
		// Do we have to do the same thing for workorder children (nested workorders) ?
		/* not sure
		for(MboRemote task = children.moveFirst(); task != null; task = children.moveNext() ) {
			if ( !task.isNull("TASKID") && dataToCopy.containsKey(task.getInt("TASKID"))) {
				task.copyValue(dataToCopy.get(task.getInt("TASKID")), FIELDS_TO_COPY, FIELDS_TO_COPY, MboConstants.NONE);
			}
		}
		*/
		
	}
}
