package com.ibm.swg.app.workorder;

import java.rmi.RemoteException;

import psdi.app.jobplan.JobPlanRemote;
import psdi.mbo.MAXTableDomain;
import psdi.mbo.MboSetRemote;
import psdi.mbo.MboValue;
import psdi.util.MXException;

public class FldWOUnitsOfWork extends MAXTableDomain {

	public FldWOUnitsOfWork(MboValue mbv) {
		super(mbv);

		String[] targetKeys = new String[]{"UNITSOFWORK"};
		String[] sourceKeys = new String[]{"MEASUREUNITID"};
		setLookupKeyMapInOrder(targetKeys, sourceKeys );
	}

	@Override
	public void validate() throws MXException, RemoteException {
		restrict();
		super.validate();
	}
	
	private void restrict() {
		try {
			if ( !mboValue.getMbo().isNull("JPNUM") ) {
				JobPlanRemote jobPlan = (JobPlanRemote) mboValue.getMbo().getMboSet("$JOBPLAN","JOBPLAN","orgid = :orgid AND siteid = :siteid AND jpnum = :jpnum and :PLUSCJPREVNUM =  PLUSCREVNUM").getMbo(0);
				if ( jobPlan == null ) jobPlan = (JobPlanRemote) mboValue.getMbo().getMboSet("$JOBPLAN","JOBPLAN","orgid = :orgid AND jpnum = :jpnum and :PLUSCJPREVNUM =  PLUSCREVNUM").getMbo(0);
				if ( jobPlan == null ) jobPlan = (JobPlanRemote) mboValue.getMbo().getMboSet("$JOBPLAN","JOBPLAN","jpnum = :jpnum and :PLUSCJPREVNUM =  PLUSCREVNUM").getMbo(0);
				if ( jobPlan == null ) {
					setRelationship("MEASUREUNIT", " (orgid = :orgid and siteid = :siteid) or (orgid is null)");
				} else {
					String unitsOfWork = jobPlan.getString(DJPConstants.UNITSOFWORK);
					String sql = "measureunitid = '" + unitsOfWork + "' OR exists (SELECT * FROM conversion WHERE ( frommeasureunit = '" + unitsOfWork + "' AND measureunit.measureunitid = tomeasureunit) OR (measureunit.measureunitid = frommeasureunit AND tomeasureunit = '" + unitsOfWork + "'))";
					setRelationship("MEASUREUNIT", sql);
					setListCriteria(sql);	
				}
			} else {
				setRelationship("MEASUREUNIT", " (orgid = :orgid and siteid = :siteid) or (orgid is null)");
			}
		} catch (RemoteException e) {
		} catch (MXException e) {
		}

	}
	@Override
	public MboSetRemote getList() throws MXException, RemoteException {
		restrict();
		return super.getList();
	}
	
}
